//'AwardMod BIOS Manipulation Tool
//'Copyright (C) 2001 Josef Hill
//'
//'This program is free software; you can redistribute it and/or
//'modify it under the terms of the GNU General Public License
//'as published by the Free Software Foundation; either version 2
//'of the License, or any later version.
//'
//'This program is distributed in the hope that it will be useful,
//'but WITHOUT ANY WARRANTY; without even the implied warranty of
//'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//'GNU General Public License for more details.
//'
//'You should have received a copy of the GNU General Public License
//'along with this program; if not, write to the Free Software
//'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#include "stdafx.h"
#include "lhaenc.h"



#define  CHAR_BIT 8
#define  UCHAR_MAX 255
#define  DICBIT 13
#define  DICSIZ (1U << DICBIT)
#define  MAXMATCH  256
#define  THRESHOLD  3
#define  PERC_FLAG  0X8000
#define  NC  (UCHAR_MAX + MAXMATCH + 2 - THRESHOLD)
#define  CBIT  9
#define  CODE_BIT  16
#define  NP  (DICBIT + 1)
#define  NT  (CODE_BIT + 3)
#define  PBIT  4
#define  TBIT  5
#define  NIL 0
#define  MAX_HASH_VAL (3 * DICSIZ + (DICSIZ / 512 + 1) * UCHAR_MAX)


byte maBuf[16 * 1024 + 1];
byte maCLen[NC + 1];
byte maPTLen[NT + 1];
word maCFreq[2* NC -1 + 1];
word maPFreq[2* NP -1 + 1];
word maTFreq[2* NT -1 + 1];
word maCCode[NC + 1];
word maPTCode[NT + 1];
dword maLeft[2 * NC - 1 + 1];
dword maRight[2*NC-1 + 1];
dword maHeap[NC +1 + 1];
word maLenCnt[17 + 1];
byte maText[DICSIZ * 2 + MAXMATCH + 1];
dword maLevel[DICSIZ + UCHAR_MAX + 1 + 1];
byte maChildCount[DICSIZ + UCHAR_MAX + 1 + 1];
dword maPosition[DICSIZ + UCHAR_MAX + 1 + 1];
dword maParent[DICSIZ * 2 + 1];
dword maPrev[DICSIZ * 2 + 1];
dword maNext[MAX_HASH_VAL + 1 + 1];

dword mpBuf;
dword mpCLen;
dword mpPTLen;
dword mpCFreq;
dword mpCCode;
dword mpPFreq;
dword mpPTCode;
dword mpTFreq;
dword mpLeft;
dword mpRight;
dword mpHeap;
dword mpLenCnt;
dword mpText;
dword mpLevel;
dword mpChildCount;
dword mpPosition;
dword mpParent;
dword mpPrev;
dword mpNext;

word * maFreq;
word * maSortPtr;
byte * maLen;

dword  mpFreq;
dword  mpSortPtr;
dword  mpLen;

byte* maIn;
dword mpIn;
dword mlIn;

byte* maOut;
dword mpOut;
dword mlOut;

//'io
dword mP;
dword mMP;
dword mA;
dword mR;
dword mML;
dword mI;
dword mUP;
dword mS;
dword mSBB;
dword mBC;
dword mBfS;
dword mBS;
dword mOM;
dword mOP;
dword mO;
dword mSHE;
dword mN;
dword mHS;
dword mD;
dword mCP;

dword mSEQ;

void clean();
void init_slide();
dword hash(dword iP, byte iC);
dword child(dword iQ, byte iC);
void makechild(dword iQ, byte iC, dword iR);
void split(dword iO);
void insert_node();
void delete_node();
void get_next_match();
dword mRead(dword iP,dword iNP);
void count_maTFreq();
void write_maPTLen(dword iNP,dword iNB ,dword iIS );
void write_maCLen();
void encode_c(dword iC);
void encode_p(dword iP);
void send_block();
void Output(dword iC , dword iP );
void huf_encode_start();
void huf_encode_end();
void putbits(dword iNP , dword iX );
void init_putbits();
void count_len(dword iI);
dword make_tree(dword iNP ,word * iAF , byte * iAL ,word * iAC ) ;
void downheap(dword iI );
void make_len(dword iR );
void make_code(dword iNP ,byte * iAL ,word * iAC );

void __stdcall lhaenc_setinput(byte* iStr, dword* iLen)
{
	dword lC;
	clean();
	
	mlIn = iLen[0];
	maIn = new byte[(mlIn)];
	//maIn = new byte[mlIn];
	for (lC=0;lC<mlIn ;lC++)
	{
		maIn[lC] = iStr[lC];
	}
	mpIn = 0;

	maOut = new byte[(mlIn)];
	//maOut = new byte[mlIn];
	mpOut = 0;

	init_slide();
	huf_encode_start();
	mR = mRead(DICSIZ,DICSIZ + MAXMATCH);
	mML = 0;
	mP = DICSIZ;
	insert_node();
	if (mML > mR) 
	{
		mML = mR;
	}
}


void __stdcall lhaenc_getoutput(byte* iStr, dword* iLen)
{
	dword lC;
	
	mlOut = (mpOut < mlIn ? mpOut : 0);

	for (lC=0;lC< mlOut;lC++)
	{
		iStr[lC]=maOut[lC];
	}
	iLen[0] = mpOut;
	delete maIn;
	delete maOut;
}

void __stdcall lhaenc_work(void)
{
	dword lLML;
	dword lLMP;

	while ((mR > 0) && (mUP == 0)) 
	{
		lLML = mML;
		lLMP = mMP;
		get_next_match();
		if (mML > mR) 
		{
			mML = mR;
		}
		if ((mML > lLML) | (lLML < THRESHOLD))
		{
			Output(maText[mpText + (mP -1)],0); 
		}
		else
		{
			Output(lLML + (UCHAR_MAX + 1 - THRESHOLD),(mP - lLMP -2) & (DICSIZ -1));
			while (--lLML > 0)
			{
				get_next_match();
			}
			if (mML > mR)
			{
				mML = mR;
			}
		}
		if ((mR < 2000) && (mSEQ > 2)) {
			mR = mR;
		}
	}
	huf_encode_end();
}

void clean()
{
	dword lC;

	mML = 0;
	mP = DICSIZ;

	mD = 0;
	mCP = 0;
	mMP = 0;
	mA = 0;
	mUP = 0;
	mS = 0;
	mSBB = 0;
	mBC = 0;
	mBfS = 0;
	mBS = 0;
	mOM = 0;
	mOP = 0;
	mO = 0;
	mSHE = 0;
	mN = 0;
	mHS = 0;

	for (lC=0;lC < (16 * 1024) + 1 ;lC++)
	{
		maBuf[lC] = 0;
	}
	for (lC=0;lC < NC + 1 ;lC++)
	{
		maCLen[lC] = 0;
	}
	for (lC=0;lC < NT + 1  ;lC++)
	{
		maPTLen[lC] = 0;
	}
	for (lC=0;lC < 2 * NC -1 ;lC++)
	{
		maCFreq[lC] = 0;
	}
	for (lC=0;lC < NC + 1 ;lC++)
	{
		maCCode[lC] = 0;
	}
	for (lC=0;lC < 2 * NP ;lC++)
	{
		maPFreq[lC] = 0;
	}
	for (lC=0;lC < NT + 1 ;lC++)
	{
		maPTCode[lC] = 0;
	}
	for (lC=0;lC < NT ;lC++)
	{
		maTFreq[lC] = 0;
	}
	for (lC=0;lC < 2 * NT ;lC++)
	{
		maLeft[lC] = 0;
	}
	for (lC=0;lC < 2 * NC ;lC++)
	{
		maRight[lC] = 0;
	}
	for (lC=0;lC < 2 * NC ;lC++)
	{
		maHeap[lC] = 0;
	}
	for (lC=0;lC < NC + 2 ;lC++)
	{
		maLenCnt[lC] = 0;
	}
	for (lC=0;lC < DICSIZ * 2 + MAXMATCH + 1 ;lC++)
	{
		maText[lC] = 0;
	}
	for (lC=0;lC < DICSIZ + UCHAR_MAX + 2 ;lC++)
	{
		maLevel[lC] = 0;
	}
	for (lC=0;lC < DICSIZ + UCHAR_MAX + 2 ;lC++)
	{
		maChildCount[lC] = 0;
	}
	for (lC=0;lC < DICSIZ + UCHAR_MAX + 2 ;lC++)
	{
		maPosition[lC] = 0;
	}
	for (lC=0;lC < DICSIZ * 2 + 1 ;lC++)
	{
		maParent[lC] = 0;
	}
	for (lC=0;lC < DICSIZ * 2 + 1 ;lC++)
	{
		maPrev[lC] = 0;
	}
	for (lC=0;lC < MAX_HASH_VAL + 2 ;lC++)
	{
		maNext[lC] = 0;
	}
}

void init_slide(void)
{
	dword lI;
	for (lI = DICSIZ; lI <DICSIZ + UCHAR_MAX + 1;lI++)
	{
		maLevel[mpLevel + lI] = 1;
		maPosition[mpPosition + lI] = NIL;
	}
	for (lI = DICSIZ; lI <(DICSIZ * 2) ;lI++)
	{
		maParent[mpParent + lI] = NIL;
	}
	mA = 1;
	for (lI = 1; lI <DICSIZ - 1;lI++)
	{
		maNext[mpNext + lI] = lI + 1;
	}
	maNext[mpNext  + DICSIZ -1] = NIL;
	for (lI = DICSIZ * 2; lI <MAX_HASH_VAL + 1;lI++)
	{
		maNext[mpNext  + lI] = NIL;
	}
}

dword hash(dword iP, byte iC)
{
	return (iP + (iC<<(DICBIT - 9)) + DICSIZ*2);
}

dword child(dword iQ, byte iC)
{
	dword lR;
	lR = maNext[mpNext + hash(iQ,iC)];
	maParent[mpParent] = iQ;
	while (maParent[mpParent + lR] != iQ)
	{
		lR = maNext[mpNext + lR];
	}
	return lR;
}

void makechild(dword iQ, byte iC, dword iR)
{
	dword lH;
	dword lT;
	lH = hash(iQ,iC);
	lT = maNext[mpNext + lH];
	maNext[mpNext + lH] = iR;
	maNext[mpNext + iR] = lT;
	maPrev[mpPrev + lT] = iR;
	maPrev[mpPrev + iR] = lH;
	maParent[mpParent + iR] = iQ;
	maChildCount[mpChildCount + iQ]++;
}

void split(dword iO)
{
	
	dword lN;
	dword lT;
	lN = mA;
	mA = maNext[mpNext + lN];
	maChildCount[mpChildCount + lN] = 0;
	lT = maPrev[mpPrev + iO];
	maPrev[mpPrev + lN] = lT;
	maNext[mpNext + lT] = lN;
	lT = maNext[mpNext + iO];
	maNext[mpNext + lN] = lT;
	maPrev[mpPrev + lT] = lN;
	maParent[mpParent + lN] = maParent[ mpParent + iO];
    maLevel[mpLevel + lN] = mML;
    maPosition[mpPosition + lN] = mP;
    makechild (lN, (byte) maText[mpText + (mMP + mML)], iO);
    makechild (lN, (byte) maText[mpText + (mP + mML)], mP);
}










void insert_node()
{
	dword lQ;
    dword lR;
    dword lJ;
    dword lT;
    dword lT1;
    dword lT2;
	byte lC;
	
    if (mML >= 4)
	{
        mML--;
        lR = (mMP + 1) | DICSIZ;
        while ((lQ = maParent[mpParent + lR]) == NIL)
		{
            lR = maNext[mpNext + lR];
        }
        while ((maLevel[mpLevel + lQ]) >= mML)
		{
			lR = lQ;
            lQ = maParent[mpParent + lQ];
        }
        lT = lQ;
        while (maPosition[mpPosition + lT] >= PERC_FLAG )
		{
            maPosition[mpPosition + lT] = mP;
            lT = maParent[mpParent + lT];
		}
        if (lT < DICSIZ) 
		{
			maPosition[mpPosition + lT] = mP | PERC_FLAG;
		}
	}
	else 
	{
		lQ = maText[mpText + (mP)] + DICSIZ;
		lC = (byte) maText[mpText + (mP + 1)];
        if ((lR = child(lQ, lC)) == NIL) 
		{
            makechild (lQ, lC, mP);
            mML = 1;
            return;
        }
        mML = 2;
    }
	
    while (0 == 0)
	{
		
        if (lR >= DICSIZ) 
		{
            lJ = MAXMATCH;
            mMP = lR;
        } 
		else 
		{
            lJ = maLevel[mpLevel + lR];
            mMP = maPosition[mpPosition + lR] & (~PERC_FLAG);
        }
        if (mMP >= mP) 
		{
            mMP -=  DICSIZ;
        }
        lT1 = mpText + (mP + mML);
        lT2 = mpText + (mMP + mML);
		
        while (mML < lJ)
		{
            if (maText[lT1] != maText[lT2]) 
			{
                split (lR);
                return;
            }
            mML++;
            lT1++;
            lT2++;
        }
		
        if (mML >= MAXMATCH) 
		{
			break;		
		}
        maPosition[mpPosition + lR] = mP;
        lQ = lR;
        if ((lR = child(lQ,(byte)  maText[lT1])) == NIL) 
		{
            makechild (lQ, (byte)maText[lT1], mP);
            return;
        }
        mML++;
    }
	
    lT = maPrev[mpPrev + lR];
    maPrev[mpPrev + mP] = lT;
    maNext[mpNext + lT] = mP;
    lT = maNext[mpNext + lR];
    maNext[mpNext + mP] = lT;
    maPrev[mpPrev + lT] = mP;
    maParent[mpParent + mP] = lQ;
    maParent[mpParent + lR] = NIL;
    maNext[mpNext + lR] = mP;  /* special use of next() */
}

void delete_node()
{
    dword lQ;
    dword lR;
    dword lS;
    dword lT;
    dword lU;
    if (maParent[mpParent + mP] == NIL) 
	{ 
		return;
	}
    lR = maPrev[mpPrev + mP];
    lS = maNext[mpNext + mP];
    maNext[mpNext + lR] = lS;
    maPrev[mpPrev + lS] = lR;
    lR = maParent[mpParent + mP];
    maParent[mpParent + mP] = NIL;
    if (lR >= DICSIZ) 
	{ 
		return;
	}
    if (--maChildCount[mpChildCount + lR] > 1) 
	{ 
		return;
	}
    lT = maPosition[mpPosition + lR] & (~PERC_FLAG);
    if (lT >= mP)
	{ 
		lT -= DICSIZ;
	}
    lS = lT;
    lQ = maParent[mpParent + lR];
	lU = maPosition[mpPosition + lQ];
    while ((lU & PERC_FLAG) != 0)
	{
        lU = lU & ~PERC_FLAG;
        if (lU >= mP) 
		{ 
			lU = lU - DICSIZ;
		}
        if (lU > lS) 
		{ 
			lS = lU;
		}
        maPosition[mpPosition + lQ] = (lS | DICSIZ);
        lQ = maParent[mpParent + lQ];

		lU = maPosition[mpPosition + lQ];
    }
    if (lQ < DICSIZ) 
	{
        if (lU >= mP) 
		{
			lU = lU - DICSIZ;
		}
        if (lU > lS) 
		{ 
			lS = lU;
		}
        maPosition[mpPosition + lQ] = lS | DICSIZ | PERC_FLAG;
    }
    lS = child(lR, (byte)maText[mpText + lT + maLevel[mpLevel + lR]]);
    lT = maPrev[mpPrev + lS];
    lU = maNext[mpNext + lS];
    maNext[mpNext + lT] = lU;
    maPrev[mpPrev + lU] = lT;
    lT = maPrev[mpPrev + lR];
    maNext[mpNext + lT] = lS;
    maPrev[mpPrev + lS] = lT;
    lT = maNext[mpNext + lR];
    maPrev[mpPrev + lT] = lS;
    maNext[mpNext + lS] = lT;
    maParent[mpParent + lS] = maParent[mpParent + lR];
    maParent[mpParent + lR] = NIL;
    maNext[mpNext + lR] = mA;
    mA = lR;
}

void get_next_match()
{
	dword lN;
	mR--;
	if (mR == 1363)
	{
		mR = mR;
	}
    if (++mP == (DICSIZ * 2)) 
	{
        for (lN = 0;lN < DICSIZ + MAXMATCH;lN++)
		{
            maText[mpText + lN] = maText[mpText + DICSIZ + lN];
        }
        lN = mRead(DICSIZ + MAXMATCH, DICSIZ);
        mR = mR + lN;
        mP = DICSIZ;
    }
    delete_node();
    insert_node();
}


dword mRead(dword iP,dword iNP)
{
	dword lI;
    iNP = ((iNP > mlIn - mpIn) ? mlIn - mpIn : iNP);
    for (lI = 0;lI<iNP;lI++)
	{
        maText[mpText + iP + lI] = maIn[mpIn];
        mpIn++;
    }
	mSEQ++;
    return iNP;
}

/***** encoding *****/
void count_maTFreq()
{
	dword lI;
    dword lK;
    dword lN;
    dword lC;
    for (lI = 0;lI< NT;lI++)
	{
        maTFreq[mpTFreq + lI] = 0;
    }
    lN = NC;
    while ((lN > 0) && (maCLen[mpCLen + lN - 1] == 0))
	{
        lN--;
    }
    lI = 0;
    while (lI < lN)
	{
        lK = maCLen[mpCLen + lI++];
        if (lK == 0)
		{
            lC = 1;
            while ((lI < lN) && (maCLen[mpCLen + lI] == 0))
			{
                lI++;
                lC++;
            }
            while (0==0)
			{
				if (lC <= 2)
				{
					maTFreq[mpTFreq + 0] = maTFreq[mpTFreq + 0] + (word) lC;
					break;
				}
				if (lC <= 18)
				{
					maTFreq[mpTFreq + 1]++;
					break;
				}
				if (lC == 19)
				{
					maTFreq[mpTFreq]++;
					maTFreq[mpTFreq + 1]++;
					break;
				}

                maTFreq[mpTFreq + 2]++;
				break;
            }
        } 
		else 
		{
             maTFreq[mpTFreq + lK + 2]++;
        }
    }
}

void write_maPTLen(dword iNP,dword iNB ,dword iIS )
{
	dword lI;
	dword lK;
    while ((iNP > 0) && (maPTLen[mpPTLen + iNP - 1] == 0))
	{
        iNP--;
    }
    putbits (iNB, iNP);
    lI = 0;
    while (lI < iNP)
	{
        lK = maPTLen[mpPTLen + lI++];
        if (lK <= 6)
		{
            putbits( 3, lK);
        } 
		else 
		{
            putbits (lK - 3, (1 << (lK - 3)) - 2);
        }
        if (lI == iIS) 
		{
            while ((lI < 6) && (maPTLen[mpPTLen + lI] == 0))
			{
                lI++;
            }
            putbits (2, (lI - 3) & 3);
        }
    }
}

void write_maCLen()
{
	dword lI;
	byte lK;
	dword lN;
	dword lC;
    lN = NC;
    while ((lN > 0) && (maCLen[mpCLen + lN - 1] == 0))
	{
        lN--;
    }
    putbits (CBIT, lN);
    lI = 0;
    while (lI < lN)
	{
        lK = (byte)maCLen[mpCLen + lI++];
        if (lK == 0) 
		{
            lC = 1;
            while ((lI < lN) && (maCLen[mpCLen + lI] == 0))
			{
                lI++;
                lC++;
            }


            while (0==0)
			{
				if (lC <= 2)
				{
					for (lK = 0;lK< lC;lK++ )
					{
						putbits (maPTLen[mpPTLen + 0], maPTCode[mpPTCode + 0]);
					}
					break;
				}
				if (lC <= 18)
				{
					putbits (maPTLen[mpPTLen + 1], maPTCode[ mpPTCode + 1]);
					putbits (4, lC - 3);
					break;
				}
				if (lC == 19)
				{
					putbits (maPTLen[mpPTLen + 0], maPTCode[mpPTCode + 0]);
					putbits (maPTLen[mpPTLen + 1], maPTCode[mpPTCode + 1]);
					putbits (4, 15);
					break;
				}

                putbits (maPTLen[mpPTLen + 2], maPTCode[mpPTCode + 2]);
                putbits (CBIT, lC - 20);
				break;
            }
        } 
		else 
		{
			putbits( maPTLen[mpPTLen + lK + 2], maPTCode[mpPTCode + lK + 2]);
        }
    }
}


void encode_c(dword iC)
{
    putbits( maCLen[mpCLen + iC], maCCode[mpCCode + iC]);
}

void encode_p(dword iP)
{
	dword lC;
	dword lQ;
    lC = 0;
    lQ = iP;
    while (lQ != 0)
	{
        lQ >>= 1;
        lC++;
    }
    putbits( maPTLen[mpPTLen + lC], maPTCode[mpPTCode + lC]);
    if (lC > 1)
	{
        putbits (lC - 1, iP & (65535 >> (17 - lC)));
    }
}

void send_block()
{
    dword lI ;
    dword lK ;
    dword lF ;
    dword lP ;
	dword lR;
	dword lS;
    lR = make_tree(NC, maCFreq  , maCLen , maCCode );
    lS = maCFreq[mpCFreq + lR];
    putbits (16, lS);
    if (lR >= NC) 
	{
        count_maTFreq();
        lR = make_tree(NT, maTFreq , maPTLen , maPTCode );
        if (lR >= NT) 
		{
            write_maPTLen( NT, TBIT, 3);
        }
		else 
		{
            putbits( TBIT, 0);
            putbits (TBIT, lR);
        }
        write_maCLen();
    } 
	else 
	{
        putbits (TBIT, 0);
        putbits (TBIT, 0);
        putbits (CBIT, 0);
        putbits (CBIT, lR);
    }
    lR = make_tree(NP, maPFreq , maPTLen , maPTCode );
    if (lR >= NP) 
	{
        write_maPTLen( NP, PBIT, -1);
    } 
	else 
	{
        putbits (PBIT, 0);
        putbits (PBIT, lR);
    }
    lP = 0;
    for (lI = 0;lI< lS ;lI++)
	{
        if (lI % CHAR_BIT == 0) 
		{
            lF = maBuf[mpBuf + lP++];
        }
		else 
		{
            lF <<=1;
        }
        if (lF & (1<< (CHAR_BIT - 1))) 
		{
            encode_c( maBuf[mpBuf + lP++] + (1<< CHAR_BIT));
            lK = (maBuf[mpBuf + lP++]<< CHAR_BIT);
            lK = lK + maBuf[mpBuf + lP++];
            encode_p (lK);
        } 
		else 
		{
            encode_c (maBuf[mpBuf + lP++]);
        }
    }
    for (lI = 0;lI<  NC + 1; lI++)
	{
        maCFreq[mpCFreq + lI] = 0;
    }
    for (lI = 0;lI<  NP + 1; lI++)
	{
        maPFreq[mpPFreq + lI] = 0;
    }
}

void Output(dword iC,dword  iP)
{
    mOM >>=1;
    if (mOM == 0)
	{
        mOM = 1<< (CHAR_BIT - 1);
        if (mOP >= mBfS - (3 * CHAR_BIT))
		{
            send_block();
            mOP = 0;
        }
        mCP = mOP++;
        maBuf[mpBuf + mCP] = 0;
    }
    maBuf[mpBuf + mOP++] = (byte) iC;
    maCFreq[mpCFreq + iC]++;
    if (iC >= (1<< CHAR_BIT)) 
	{
        maBuf[mpBuf + mCP] |= mOM;
        maBuf[mpBuf + mOP++] = (byte) (((word) iP )>> CHAR_BIT);
        maBuf[mpBuf + mOP++] = (byte) iP ;
        iC = 0;
        while (iP != 0)
		{
            iP >>=1;
            iC++;
        }
        maPFreq[mpPFreq + iC]++;
    }
}

void huf_encode_start()
{
	dword lI;
    mBfS = 16 * 1024;
    maBuf[mpBuf + 0] = 0;
    for (lI = 0;lI< NC + 1; lI++)
	{
        maCFreq[mpCFreq + lI] = 0;
    }
    for (lI = 0;lI< NP + 1; lI++)
	{
        maPFreq[mpPFreq + lI] = 0;
    }
    mOM = 0;
    mOP = mOM;
    init_putbits();
}

void huf_encode_end()
{
    send_block();
    putbits (CHAR_BIT - 1, 0);
}

void putbits(dword iNP , dword iX )
{
	if (mpOut >= mlIn)
	{
		mpOut++;
		return;
	}

    if (iNP < mBC)
	{
        mBC = mBC - iNP;
        mSBB = mSBB | (iX<< mBC);
    } 
	else 
	{
        iNP = iNP - mBC;
        maOut[mpOut] = (byte) (mSBB | iX>> iNP) ;
        mpOut++;
        
        if (iNP < CHAR_BIT)
		{
            mBC = CHAR_BIT - iNP;
            mSBB = (iX<< mBC);
        } 
		else 
		{
            maOut[mpOut] = (byte) (iX>> (iNP - CHAR_BIT));
            mpOut++;
            
            mBC = 2 * CHAR_BIT - iNP;
            mSBB = (iX<< mBC);
        }
    }
}

void init_putbits()
{
    mBC = CHAR_BIT;
    mSBB = 0;
}

void count_len(dword iI)
{
    if (iI < mN )
	{
        maLenCnt[mpLenCnt + ((mD < 16)? mD: 16)]++;
    } 
	else 
	{
        mD++;
        count_len (maLeft[mpLeft + iI]);
        count_len (maRight[mpRight + iI]);
        mD--;
    }
}








dword make_tree(dword iNP , word * iAF , byte * iAL ,word * iAC ) 
{
    dword lI  ;
    dword lJ  ;
    dword lK  ;
    dword lA  ;
    mN = iNP;
    maFreq = iAF;
    maLen = iAL;
	maSortPtr = iAC;
    lA = mN;
    mHS = 0;
    maHeap[mpHeap + 1] = 0;
    for (lI = 0;lI< mN;lI++)
	{
        maLen[mpLen + lI] = 0;
        if (maFreq[mpFreq + lI] != 0)
		{
            maHeap[mpHeap + ++mHS] = lI;
        }
    }
    if (mHS < 2)
	{
        iAC[maHeap[mpHeap + 1]] = 0;
        return maHeap[mpHeap + 1];
    }
    for (lI = mHS / 2; lI > 1 -1; lI--)
	{
        downheap (lI);
    }
    //'what we really want here is access to iAC from the rest of this module
      //'for some reason this doesn't work nearly the same way it does in C
	mpSortPtr = 0;
    while (mHS > 1)
	{
        lI = maHeap[mpHeap + 1];
        if (lI < mN)
		{
            maSortPtr[mpSortPtr] = (word) lI;
            mpSortPtr++;
        }
        maHeap[mpHeap + 1] = maHeap[mpHeap + mHS--];
        downheap (1);
        lJ = maHeap[mpHeap + 1];
        if (lJ < mN)
		{
            maSortPtr[mpSortPtr] = (word) lJ;
            mpSortPtr++;
        }
        lK = lA++;
        maFreq[mpFreq + lK] = maFreq[mpFreq + lI] + maFreq[mpFreq + lJ];
        maHeap[mpHeap + 1] = lK;
        downheap (1);
        maLeft[mpLeft + lK] = lI;
        maRight[mpRight + lK] = lJ;
    }
	mpSortPtr = 0;
    make_len (lK);
    make_code (iNP, iAL, iAC);
    return lK;
}

void downheap(dword iI )
{
    dword lJ;
    dword lK;
    dword ltv1;
    dword ltv2;
    lK = maHeap[mpHeap + iI];
    while ((lJ = 2 * iI) <= mHS)
	{
        ltv1 = maFreq[mpFreq + maHeap[mpHeap + lJ]];
        ltv2 = maFreq[mpFreq + maHeap[mpHeap + lJ + 1]];
        if ((lJ < mHS) && (ltv1 > ltv2) )
		{
            lJ++;
        }
        if (maFreq[mpFreq + lK] <= maFreq[mpFreq + maHeap[mpHeap + lJ]])
		{ 
			break;
		}
        maHeap[ mpHeap + iI] = maHeap[ mpHeap + lJ];
        iI = lJ;
    }
    maHeap[mpHeap + iI] = lK;
}

void make_len(dword iR )
{
    dword lI ;
    dword lK ;
    dword lC ;
    for (lI = 0 ;lI < 16 + 1;lI++)
	{
        maLenCnt[mpLenCnt + lI] = 0;
    }
    count_len( iR);
    lC = 0;
    for (lI = 16 ;lI> 1 -1; lI--)
	{
        lC += ((maLenCnt[mpLenCnt + lI]) << (16 - lI));
    }
    while (lC != (1<< 16))
	{
        maLenCnt[mpLenCnt + 16]--;
        for (lI = 15 ;lI> 1-1; lI--)
		{
            if (maLenCnt[mpLenCnt + lI]!= 0)
			{
                maLenCnt[mpLenCnt + lI]--;
                maLenCnt[mpLenCnt + lI + 1] += 2;
                break;
            }
        }
        lC--;
    }

    for (lI = 16; lI > 1 -1;lI--)
	{
        lK = maLenCnt[mpLenCnt + lI];
        while (--lK != 0xFFFFFFFF)
		{
            maLen[mpLen + maSortPtr[mpSortPtr]] = (byte) lI;
            mpSortPtr++;
        }
    }
}

void make_code(dword iNP ,byte * iAL ,word * iAC )
{
	dword lI;
	word start[18];
	start[0] = 0;
    start[1] = 0;
    for (lI = 1; lI< 16 + 1; lI++)
	{
        start[lI + 1] = (start[lI] + maLenCnt[mpLenCnt + lI]) << 1;
    }
    for (lI = 0; lI < iNP + 1;lI++)
	{
        iAC[ lI] = start[iAL[lI]]++;
    }
}











